:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022

# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# Some of the ideas and code for the sunos 4.1.X version of titan was
# modified from code from a program secure_sun author David Safford

TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh
 
Intro() {

cat << EOF_INTRO

	Check for extra root accounts
EOF_INTRO

}

Check() {
#
t_echo 2
t_echo 2 "   " Checking /etc/passwd
if grep  "^[^:]*:[^:]*:0:" /etc/passwd |egrep -v '(root:|\+:)'
then
	t_echo 0  "  The above are accounts with root id. FAIL CHECK"
else
	t_echo 2  "  There are no no-root accounts with uid 0 PASSES CHECK"
fi

if grep  "^[^:]*:[^:]*:0:" /etc/passwd |egrep -v '(root:|\+:)'
then
        t_echo 0  "   The above YP/NIS are  accounts with root id. FAIL CHECK"
else
	t_echo 2  "    There are no no-root YP/NIS accounts with uid 0 PASSES CHECK"
fi
}


Fix() {
if grep  "^[^:]*:[^:]*:0:" /etc/passwd |egrep -v '(root:|\+:)'
then
	ed - /etc/passwd <<- !
		g/^[^:]*:[^:]*:0:/s/:/:*/
		g/^root:/s/:\*/:/
		w
		g/^+:/s/:\*/:/
		w
		q
		!
else
	t_echo 2 "     There are no non-root accounts with uid 0. PASSES CHECK"
fi
if test -s /etc/passwd
then
t_echo 2 "    Checking /etc/passwd"
if grep  "^[^:]*:[^:]*:0:" /etc/passwd |egrep -v '(root:|\+:)'
then
		ed - /etc/passwd <<- !
			g/^[^:]*:[^:]*:0:/s/:/:*/
			g/^root:/s/:\*/:/
			w
			g/^+:/s/:\*/:/
			w
			q
		!
		t_echo 0 Deleting non-root NIS/YP accounts with uid 0
else
	t_echo 2 "   There are no non-root NIS/YP accounts with uid 0. PASSES CHECK"

fi
fi
}

action=$1
case $action in
 -[Ff]*)
Fix
;;
 -[Vv]*)
Check
;;
 -[Ii]*)
Intro
;;
 
*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 
        t_echo 1 " "
;;
esac

